/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of Kadm5.xs. Do not edit this file, edit Kadm5.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Kadm5.xs"
/*
 * Copyright (c) 2003, Stockholms Universitet
 * (Stockholm University, Stockholm Sweden)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the university nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <sys/un.h>
#include <krb5.h>
#include <kadm5/admin.h>
#include <kadm5/kadm5_err.h>

#include "consts.h"

typedef struct shandle_t {
  int modcount;
  void *ptr;
  kadm5_config_params params;
  krb5_context context;
} shandle_t;

typedef struct sprincipal_t {
  shandle_t               *handle;
  int                      mask;
  kadm5_principal_ent_rec  principal;
} sprincipal_t;

static sprincipal_t *
create_sprincipal(shandle_t *handle)
{
  sprincipal_t *p = (sprincipal_t *)safemalloc(sizeof(sprincipal_t));
  
  memset(p,0,sizeof(*p));
  p->handle = handle;
  return p;
}

static void
destroy_sprincipal(sprincipal_t *spp)
{
  kadm5_free_principal_ent(spp->handle,&spp->principal);
  safefree(spp);
}

static shandle_t *
sv2server_handle(SV *sv)
{
  if (SvROK(sv) && sv_isa(sv,"Heimdal::Kadm5::SHandle"))
    return (shandle_t *)SvIV(SvRV(sv));
  else
    croak("Argument to sv2server_handle not referenced in package \"Heimdal::Kadm5::SHandle\"");
}

static sprincipal_t *
sv2sprincipal(SV *sv)
{
  if (SvROK(sv) && sv_isa(sv,"Heimdal::Kadm5::Principal"))
    return (sprincipal_t *)SvIV(SvRV(sv));
  else
    croak("Argument to sv2kadm5_principal not referenced in package \"Heimdal::Kadm5::Principal\"");
}

static int
set_param_strval(HV *hv, char **str, char *key)
{
  SV **val = hv_fetch(hv, key, strlen(key), 0);
  //fprintf(stderr,"%s=\"%s\"\n",key,val != NULL ? SvPV_nolen(*val):"(null)");
  if (val != NULL)
    {
       *str = SvPV_nolen(*val);
       return 1;
     }
  return 0;
}

static int
set_param_intval(HV *hv, int *ival, char *key)
{
  SV **val = hv_fetch(hv, key, 0, 0);
  if (val)
    {
      *ival = (int)SvIV(*val);
      return 1;
    }
  return 0;
}

static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}


struct kadm_func {
    kadm5_ret_t (*chpass_principal) (void *, krb5_principal, char*);
    kadm5_ret_t (*create_principal) (void*, kadm5_principal_ent_t, 
                                     u_int32_t, char*);
    kadm5_ret_t (*delete_principal) (void*, krb5_principal);
    kadm5_ret_t (*destroy) (void*);
    kadm5_ret_t (*flush) (void*);
    kadm5_ret_t (*get_principal) (void*, krb5_principal, 
                                  kadm5_principal_ent_t, u_int32_t);
    kadm5_ret_t (*get_principals) (void*, const char*, char***, int*);
    kadm5_ret_t (*get_privs) (void*, u_int32_t*);
    kadm5_ret_t (*modify_principal) (void*, kadm5_principal_ent_t, u_int32_t);
    kadm5_ret_t (*randkey_principal) (void*, krb5_principal, 
                                      krb5_keyblock**, int*);
    kadm5_ret_t (*rename_principal) (void*, krb5_principal, krb5_principal);
    kadm5_ret_t (*chpass_principal_with_key) (void *, krb5_principal,
                                              int, krb5_key_data *);
};

typedef struct kadm5_client_context {
    krb5_context context;
    krb5_boolean my_context;
    struct kadm_func funcs;
    /* */
    krb5_auth_context ac;
    char *realm;
    char *admin_server;
    int kadmind_port;
    int sock;
    char *client_name;
    char *service_name;
    krb5_prompter_fct prompter;
    const char *keytab;
    krb5_ccache ccache;
    kadm5_config_params *realm_params;
}kadm5_client_context;



#line 175 "Kadm5.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 218 "Kadm5.c"

XS(XS_Heimdal__Kadm5__SHandle_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, sv");
    {
	SV *	self = ST(0);
	SV *	sv = ST(1);
	shandle_t *	RETVAL;
#line 173 "Kadm5.xs"
     {
       if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVHV)
       {
	 HV *hv = (HV *)SvRV(sv);
	 shandle_t *handle = (shandle_t *)safemalloc(sizeof(shandle_t));
	 kadm5_ret_t ret;

	 memset(handle,0,sizeof(*handle));
	 ret = krb5_init_context(&handle->context);
	 if (ret)
	 {
	   safefree(handle);
	   croak("[Heimdal::Kadm5] krb5_init_context failed: %s\n",krb5_get_err_text(handle->context, ret));
	   handle = NULL;
	   goto cleanup;
	 }

	 if (set_param_strval(hv,&handle->params.realm,"Realm"))
	 {
           fprintf(stderr,"Realm=\"%s\"\n",handle->params.realm);
	   krb5_set_default_realm(handle->context, handle->params.realm);
	   handle->params.mask |= KADM5_CONFIG_REALM;
	 }
	 /* set_param_strval(hv,&handle->params.profile,"Profile"); */
	 if (set_param_intval(hv,&handle->params.kadmind_port,"Port"))
       	    handle->params.mask |= KADM5_CONFIG_KADMIND_PORT;
	 if (set_param_strval(hv,&handle->params.admin_server,"Server"))
	    handle->params.mask |= KADM5_CONFIG_ADMIN_SERVER;

	 cleanup:
	 RETVAL = handle;
       }
       else
       {
         croak("[Heimdal::Kadm5] Argument to \"Heimdal::Kadm5::SHandle::new\" must be a hash-reference");
	 RETVAL = NULL;
       }
     }
#line 273 "Kadm5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Heimdal::Kadm5::SHandle", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__SHandle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
#line 218 "Kadm5.xs"
     {
       if (handle->modcount > 0)
	 {
	   kadm5_c_flush(handle->ptr);
	 }
       if (handle->ptr)
          kadm5_c_destroy(handle->ptr);
       if (handle->context)
          krb5_free_context(handle->context);
       safefree(handle);
     }
#line 306 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_init_with_password); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_init_with_password)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "handle, client_name, password, service_name, struct_version, api_version");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	client_name = (char *)SvPV_nolen(ST(1));
	char *	password = (char *)SvPV_nolen(ST(2));
	char *	service_name = (char *)SvPV_nolen(ST(3));
	unsigned long	struct_version = (unsigned long)SvUV(ST(4));
	unsigned long	api_version = (unsigned long)SvUV(ST(5));
#line 239 "Kadm5.xs"
     {
       kadm5_ret_t ret = kadm5_c_init_with_password_ctx(handle->context,
							client_name,
							password,
							KADM5_ADMIN_SERVICE, 
							&handle->params,
							struct_version, 
							api_version,
							&handle->ptr);
       if(ret)
	    croak("[Heimdal::Kadm5] kadm5_c_init_with_password_ctx failed: %s\n",
		  krb5_get_err_text(handle->context, ret));

       if (password != NULL && *password != '\0')
           ((kadm5_client_context *)handle->ptr)->prompter = NULL;
     }
#line 346 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_init_with_skey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_init_with_skey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "handle, client_name, keytab, service_name, struct_version, api_version");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	client_name = (char *)SvPV_nolen(ST(1));
	char *	keytab = (char *)SvPV_nolen(ST(2));
	char *	service_name = (char *)SvPV_nolen(ST(3));
	unsigned long	struct_version = (unsigned long)SvUV(ST(4));
	unsigned long	api_version = (unsigned long)SvUV(ST(5));
#line 265 "Kadm5.xs"
     {
       kadm5_ret_t ret = kadm5_c_init_with_skey_ctx(handle->context,
						    client_name,
						    keytab,
						    KADM5_ADMIN_SERVICE, 
						    &handle->params,
						    struct_version, 
						    api_version,
						    &handle->ptr);
       if(ret)
	    croak("[Heimdal::Kadm5] kadm5_c_init_with_skey_ctx failed: %s\n",
		  krb5_get_err_text(handle->context, ret));
     }
#line 383 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
#line 283 "Kadm5.xs"
     {
       kadm5_ret_t ret = kadm5_c_flush(handle->ptr);
       if (ret)
	 croak("[Heimdal::Kadm5] kadm5_c_flush failed: %s\n",krb5_get_err_text(handle->context, ret));
       handle->modcount = 0;
     }
#line 408 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_modify_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_modify_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, spp, mask");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	sprincipal_t *	spp = sv2sprincipal(ST(1));
	int	mask = (int)SvIV(ST(2));
#line 296 "Kadm5.xs"
     {
       kadm5_ret_t ret;

       if (mask == 0)
	 mask = spp->mask;
       ret = kadm5_c_modify_principal(handle->ptr, &spp->principal, mask);
       if (ret)
	 {
	   if (ret)
	     croak("[Heimdal::Kadm5] kadm5_c_modify_principal failed: %s\n",
		   krb5_get_err_text(handle->context, ret));
	 }
       handle->modcount++;
     }
#line 443 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_randkey_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_randkey_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "handle, name");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;
#line 316 "Kadm5.xs"
     {
       krb5_keyblock *new_keys;
       int n_keys, i;
       krb5_principal principal;
       krb5_error_code err;
       kadm5_ret_t ret;

       err = krb5_parse_name(handle->context, name, &principal);
       if (err)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, err));

       ret = kadm5_randkey_principal(handle->ptr, principal, &new_keys, &n_keys);
       if(ret)
	 {
	   krb5_free_principal(handle->context, principal);
	   croak("[Heimdal::Kadm5] kadm5_c_randkey_principal failed: %s\n",
		 krb5_get_err_text(handle->context, ret));
	 }
       for(i = 0; i < n_keys; i++)
	 krb5_free_keyblock_contents(handle->context, &new_keys[i]);
       free(new_keys);
       krb5_free_principal(handle->context, principal);
       handle->modcount++;
       RETVAL = n_keys;
     }
#line 491 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__SHandle_c_chpass_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_chpass_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, name, password");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
	char *	password = (char *)SvPV_nolen(ST(2));
#line 351 "Kadm5.xs"
     {
       kadm5_ret_t ret;
       krb5_error_code ret2;
       krb5_principal principal;

       ret2 = krb5_parse_name(handle->context, name, &principal);
       if (ret2)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret2));

       ret = kadm5_c_chpass_principal(handle->ptr,principal,password);
       if (ret)
	 croak("[Heimdal::Kadm5] kadm5_c_chpass_principal failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret));
       handle->modcount++;
     }
#line 529 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_create_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_create_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "handle, spp, password, mask");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	sprincipal_t *	spp = sv2sprincipal(ST(1));
	char *	password = (char *)SvPV_nolen(ST(2));
	int	mask = (int)SvIV(ST(3));
#line 375 "Kadm5.xs"
     {
       kadm5_ret_t ret;

       if (mask == 0)
	 mask = spp->mask;

       ret = kadm5_c_create_principal(handle->ptr,&spp->principal,mask,password);
       if (ret)
	 {
	   char *p;
	   krb5_error_code ret2;

	   ret2 = krb5_unparse_name(handle->context,spp->principal.principal,&p);
	   if (ret2)
	     {
	       safefree(p);
	       croak("[Heimdal::Kadm5] krb5_unparse_name failed: %s\n",
		     krb5_get_err_text(spp->handle->context, ret2));
	     }
	   croak("[Heimdal::Kadm5] krb5_c_create_principal failed on \"%s\": %s\n",
		 p,krb5_get_err_text(handle->context, ret));
	 }
       handle->modcount++;
     }
#line 575 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_rename_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_rename_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, src, trg");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	src = (char *)SvPV_nolen(ST(1));
	char *	trg = (char *)SvPV_nolen(ST(2));
#line 406 "Kadm5.xs"
     {
       krb5_error_code ret;
       krb5_principal source, target;
       kadm5_ret_t err;

       ret = krb5_parse_name(handle->context, src, &source);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
		 src,krb5_get_err_text(handle->context, ret));
	 }

       ret = krb5_parse_name(handle->context, trg, &target);
       if (ret)
	 {
	   krb5_free_principal(handle->context, target);
	   croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
		 trg,krb5_get_err_text(handle->context, ret));
	 }

       err = kadm5_c_rename_principal(handle->ptr, source, target);
       if (err)
	 {
	   krb5_free_principal(handle->context, source);
	   krb5_free_principal(handle->context, target);
	   croak("[Heimdal::Kadm5] kadm5_rename_principal \"%s\" to \"%s\" failed: %s\n",
		 src,trg,krb5_get_err_text(handle->context, err));
	 }
       krb5_free_principal(handle->context, source);
       krb5_free_principal(handle->context, target);
       handle->modcount++;
     }
#line 628 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_delete_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_delete_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "handle, name");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
#line 444 "Kadm5.xs"
     {
       krb5_error_code ret;
       krb5_principal principal;
       kadm5_ret_t err;

       ret = krb5_parse_name(handle->context, name, &principal);
       if (ret)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret));

       err = kadm5_c_delete_principal(handle->ptr,principal);
       if (err)
	 {
	   krb5_free_principal(handle->context, principal);
	   croak("[Heimdal::Kadm5] kadm5_c_delete_principal failed for \"%s\": %s\n",
		 name,krb5_get_err_text(handle->context, err));
	 }
       handle->modcount++;
       krb5_free_principal(handle->context, principal);
     }
#line 668 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__SHandle_c_get_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_get_principal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, name, mask");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
	IV	mask = (IV)SvIV(ST(2));
	sprincipal_t *	RETVAL;
#line 472 "Kadm5.xs"
     {
       krb5_principal principal;
       krb5_error_code ret;
       sprincipal_t *spp;

       ret = krb5_parse_name(handle->context, name, &principal);
       if (ret)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret));

       spp = create_sprincipal(handle);
       ret = kadm5_c_get_principal(handle->ptr,
				   principal,
				   &spp->principal,
				   mask);
       if (ret)
	 {
           if (ret == KADM5_UNK_PRINC) {
              destroy_sprincipal(spp); 
              spp = NULL;
           } else {
	      krb5_free_principal(handle->context, principal);
              destroy_sprincipal(spp); 
	      croak("[Heimdal::Kadm5] kadm5_c_get_principal failed for \"%s\": %s\n",
		    name,krb5_get_err_text(handle->context, ret));
           }
	 }
       krb5_free_principal(handle->context,principal);
       RETVAL = spp;
     }
#line 720 "Kadm5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Heimdal::Kadm5::Principal", (void *)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__SHandle_c_get_principals); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_get_principals)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "handle, exp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	char *	exp = (char *)SvPV_nolen(ST(1));
#line 510 "Kadm5.xs"
     {
       char **princs;
       int num_princs,i;
       kadm5_ret_t ret;

       ret = kadm5_c_get_principals(handle->ptr,exp,&princs,&num_princs);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] kadm5_c_get_principals failed for \"%s\": %s\n",
		 exp,krb5_get_err_text(handle->context, ret));
	 }
       EXTEND(SP,num_princs);
       for (i = 0; i < num_princs; i++)
	 {
	   PUSHs(sv_2mortal(newSVpv(princs[i],0)));
	 }
       kadm5_free_name_list(handle->ptr,princs,&num_princs);
     }
#line 762 "Kadm5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Heimdal__Kadm5__SHandle_c_get_privs); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_get_privs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	int	RETVAL;
	dXSTARG;
#line 533 "Kadm5.xs"
     {
       int privs;
       kadm5_ret_t ret = kadm5_c_get_privs(handle->ptr,&privs);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] kadm5_c_get_privs failed: %s\n",
		 krb5_get_err_text(handle->context, ret));
	 }
       RETVAL = privs;
     }
#line 794 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__SHandle_c_ext_keytab); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__SHandle_c_ext_keytab)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, spp, keytab");
    {
	shandle_t *	handle = sv2server_handle(ST(0));
	sprincipal_t *	spp = sv2sprincipal(ST(1));
	char *	keytab = (char *)SvPV_nolen(ST(2));
#line 552 "Kadm5.xs"
     {
       int i;
       krb5_keytab kt;
       krb5_error_code ret;

       if(keytab)
	 ret = krb5_kt_resolve(handle->context, keytab, &kt);
       else
	 ret = krb5_kt_default(handle->context, &kt);

       if (ret)
	 croak("[Heimdal::Kadm5] krb5_kt_resolv failed: %s\n",
	       krb5_get_err_text(handle->context, ret));

       for(i = 0; i < spp->principal.n_key_data; i++)
	 {
	   krb5_keytab_entry key;
	   krb5_key_data *k = &spp->principal.key_data[i];

	   key.principal = spp->principal.principal;
	   key.vno = k->key_data_kvno;
	   key.keyblock.keytype = k->key_data_type[0];
	   key.keyblock.keyvalue.length = k->key_data_length[0];
	   key.keyblock.keyvalue.data = k->key_data_contents[0];
	   ret = krb5_kt_add_entry(handle->context, kt, &key);
	   if (ret)
	     croak("[Heimdal::Kadm5] krb5_kt_add_entry failed: %s\n",
		   krb5_get_err_text(handle->context, ret));
	 }

       krb5_kt_close(handle->context, kt);
     }
#line 848 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, handle");
    {
	SV *	self = ST(0);
	shandle_t *	handle = sv2server_handle(ST(1));
	sprincipal_t *	RETVAL;
#line 592 "Kadm5.xs"
     {
       sprincipal_t *spp = create_sprincipal(handle);
       RETVAL = spp;
     }
#line 873 "Kadm5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Heimdal::Kadm5::Principal", (void *)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
#line 603 "Kadm5.xs"
     {
       destroy_sprincipal(spp);
     }
#line 897 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getPrincipal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getPrincipal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	SV *	RETVAL;
#line 611 "Kadm5.xs"
     {
       char *p;
       krb5_error_code ret;

       ret = krb5_unparse_name(spp->handle->context,spp->principal.principal,&p);
       if (ret)
	 {
	   safefree(p);
	   croak("[Heimdal::Kadm5] krb5_unparse_name failed: %s\n",
		 krb5_get_err_text(spp->handle->context, ret));
	 }
       RETVAL = newSVpv(p,0);
     }
#line 930 "Kadm5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_setPrincipal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_setPrincipal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "spp, p");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	char *	p = (char *)SvPV_nolen(ST(1));
#line 632 "Kadm5.xs"
     {
       krb5_error_code ret;

       ret = krb5_parse_name(spp->handle->context,p,&spp->principal.principal);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] krb5_parse_name failed for \"%s\": %s\n",
		 p,krb5_get_err_text(spp->handle->context, ret));
	 }
       spp->mask |= KADM5_PRINCIPAL;
     }
#line 963 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getPrincExpireTime); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getPrincExpireTime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	int	RETVAL;
	dXSTARG;
#line 648 "Kadm5.xs"
     {
       XPUSHi(spp->principal.princ_expire_time);
     }
#line 989 "Kadm5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Heimdal__Kadm5__Principal_setPrincExpireTime); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_setPrincExpireTime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	val = (IV)SvIV(ST(1));
#line 657 "Kadm5.xs"
     {
       spp->principal.princ_expire_time = val;
       spp->mask |= KADM5_PRINC_EXPIRE_TIME;
     }
#line 1014 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getLastPwdChange); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getLastPwdChange)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 666 "Kadm5.xs"
     {
       RETVAL = spp->principal.last_pwd_change;
     }
#line 1038 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getKvno); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getKvno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 676 "Kadm5.xs"
     {
       RETVAL = spp->principal.kvno;
     }
#line 1063 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getMKvno); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getMKvno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 686 "Kadm5.xs"
     {
       RETVAL = spp->principal.mkvno;
     }
#line 1088 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getPwExpiration); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getPwExpiration)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 696 "Kadm5.xs"
     {
       RETVAL = spp->principal.pw_expiration;
     }
#line 1113 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_setPwExpiration); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_setPwExpiration)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	val = (IV)SvIV(ST(1));
#line 707 "Kadm5.xs"
     {
       spp->principal.pw_expiration = val;
       spp->mask |= KADM5_PW_EXPIRATION;
     }
#line 1138 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getMaxLife); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getMaxLife)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 716 "Kadm5.xs"
     {
       RETVAL = spp->principal.max_life;
     }
#line 1162 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_setMaxLife); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_setMaxLife)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	val = (IV)SvIV(ST(1));
#line 727 "Kadm5.xs"
     {
       spp->principal.max_life = val;
       spp->mask |= KADM5_MAX_LIFE;
     }
#line 1187 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getModName); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getModName)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	SV *	RETVAL;
#line 736 "Kadm5.xs"
     {
       char *p;
       krb5_error_code ret;

       ret = krb5_unparse_name(spp->handle->context,spp->principal.mod_name,&p);
       if (ret)
	 {
	   safefree(p);
	   croak("[Heimdal::Kadm5] krb5_unparse_name failed: %s\n",
		 krb5_get_err_text(spp->handle->context, ret));
	 }
       RETVAL = newSVpv(p,0);
     }
#line 1220 "Kadm5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getModDate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getModDate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 756 "Kadm5.xs"
     {
       RETVAL = spp->principal.mod_date;
     }
#line 1246 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getPolicy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getPolicy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	SV *	RETVAL;
#line 766 "Kadm5.xs"
     {
       if (spp->principal.policy)
	 RETVAL = newSVpv(spp->principal.policy,0);
       else
	 RETVAL = &PL_sv_undef;
     }
#line 1273 "Kadm5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getMaxRenewableLife); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getMaxRenewableLife)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 779 "Kadm5.xs"
     {
       RETVAL = spp->principal.max_renewable_life;
     }
#line 1299 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_setMaxRenewableLife); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_setMaxRenewableLife)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	val = (IV)SvIV(ST(1));
#line 790 "Kadm5.xs"
     {
       spp->principal.max_renewable_life = val;
       spp->mask |= KADM5_MAX_RLIFE;
     }
#line 1324 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getLastSuccess); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getLastSuccess)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 799 "Kadm5.xs"
     {
       RETVAL = spp->principal.last_success;
     }
#line 1348 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getLastFailed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getLastFailed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 809 "Kadm5.xs"
     {
       RETVAL = spp->principal.last_failed;
     }
#line 1373 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getFailAuthCount); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getFailAuthCount)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 819 "Kadm5.xs"
     {
       RETVAL = spp->principal.fail_auth_count;
     }
#line 1398 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getFailAuthCounts); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getFailAuthCounts)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 829 "Kadm5.xs"
     {
       RETVAL = spp->principal.fail_auth_count;
     }
#line 1423 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getAttributes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getAttributes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	RETVAL;
	dXSTARG;
#line 839 "Kadm5.xs"
     {
       RETVAL = spp->principal.attributes;
     }
#line 1448 "Kadm5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_setAttributes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_setAttributes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	IV	val = (IV)SvIV(ST(1));
#line 850 "Kadm5.xs"
     {
       spp->principal.attributes = val;
       spp->mask |= KADM5_ATTRIBUTES;
     }
#line 1473 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Heimdal__Kadm5__Principal_getKeytypes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getKeytypes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	SV *	RETVAL;
#line 859 "Kadm5.xs"
     {
       int i;
       AV *lst = newAV();

       for (i = 0; i < spp->principal.n_key_data; ++i) 
	 {
	   krb5_key_data *k = &spp->principal.key_data[i];
	   krb5_error_code ret;
	   char *e_string, *s_string;
	   SV *ksv[2];

	   ret = krb5_enctype_to_string (spp->handle->context,
					 k->key_data_type[0],
					 &e_string);
	   if (ret)
	     asprintf (&e_string, "unknown(%d)", k->key_data_type[0]);
	   ksv[0] = newSVpv(e_string,0);

	   ret = krb5_salttype_to_string (spp->handle->context,
					  k->key_data_type[0],
					  k->key_data_type[1],
					  &s_string);
	   if (ret)
	     asprintf (&s_string, "unknown(%d)", k->key_data_type[1]);
	   ksv[1] = newSVpv(s_string,0);

	   av_push(lst,newRV_inc((SV *)av_make(2,ksv)));
	   free (e_string);
	   free (s_string);
	 }
       RETVAL = newRV_inc((SV *)lst);
     }
#line 1525 "Kadm5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5__Principal_getPassword); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5__Principal_getPassword)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0));
	SV *	RETVAL;
#line 898 "Kadm5.xs"
     {
#ifdef KRB5_TL_PASSWORD
       krb5_tl_data *tl = spp->principal.tl_data;

       while (tl != NULL)
         {
	   if (tl->tl_data_type == KRB5_TL_PASSWORD)
	     break;
	   tl = tl->tl_data_next;
         }

       if (tl)
	 RETVAL = newSVpv(tl->tl_data_contents,0);
       else
#endif
	 RETVAL = &PL_sv_undef;
     }
#line 1564 "Kadm5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Heimdal__Kadm5_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Heimdal__Kadm5_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	arg = (int)SvIV(ST(1));
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Heimdal__Kadm5); /* prototype to pass -Wmissing-prototypes */
XS(boot_Heimdal__Kadm5)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Heimdal::Kadm5::SHandle::new", XS_Heimdal__Kadm5__SHandle_new, file, "$$");
        newXSproto("Heimdal::Kadm5::SHandle::DESTROY", XS_Heimdal__Kadm5__SHandle_DESTROY, file, "$");
        newXSproto("Heimdal::Kadm5::SHandle::c_init_with_password", XS_Heimdal__Kadm5__SHandle_c_init_with_password, file, "$$$$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_init_with_skey", XS_Heimdal__Kadm5__SHandle_c_init_with_skey, file, "$$$$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_flush", XS_Heimdal__Kadm5__SHandle_c_flush, file, "$");
        newXSproto("Heimdal::Kadm5::SHandle::c_modify_principal", XS_Heimdal__Kadm5__SHandle_c_modify_principal, file, "$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_randkey_principal", XS_Heimdal__Kadm5__SHandle_c_randkey_principal, file, "$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_chpass_principal", XS_Heimdal__Kadm5__SHandle_c_chpass_principal, file, "$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_create_principal", XS_Heimdal__Kadm5__SHandle_c_create_principal, file, "$$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_rename_principal", XS_Heimdal__Kadm5__SHandle_c_rename_principal, file, "$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_delete_principal", XS_Heimdal__Kadm5__SHandle_c_delete_principal, file, "$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_get_principal", XS_Heimdal__Kadm5__SHandle_c_get_principal, file, "$$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_get_principals", XS_Heimdal__Kadm5__SHandle_c_get_principals, file, "$$");
        newXSproto("Heimdal::Kadm5::SHandle::c_get_privs", XS_Heimdal__Kadm5__SHandle_c_get_privs, file, "$");
        newXSproto("Heimdal::Kadm5::SHandle::c_ext_keytab", XS_Heimdal__Kadm5__SHandle_c_ext_keytab, file, "$$$");
        newXSproto("Heimdal::Kadm5::Principal::new", XS_Heimdal__Kadm5__Principal_new, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::DESTROY", XS_Heimdal__Kadm5__Principal_DESTROY, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getPrincipal", XS_Heimdal__Kadm5__Principal_getPrincipal, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::setPrincipal", XS_Heimdal__Kadm5__Principal_setPrincipal, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::getPrincExpireTime", XS_Heimdal__Kadm5__Principal_getPrincExpireTime, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::setPrincExpireTime", XS_Heimdal__Kadm5__Principal_setPrincExpireTime, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::getLastPwdChange", XS_Heimdal__Kadm5__Principal_getLastPwdChange, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getKvno", XS_Heimdal__Kadm5__Principal_getKvno, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getMKvno", XS_Heimdal__Kadm5__Principal_getMKvno, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getPwExpiration", XS_Heimdal__Kadm5__Principal_getPwExpiration, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::setPwExpiration", XS_Heimdal__Kadm5__Principal_setPwExpiration, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::getMaxLife", XS_Heimdal__Kadm5__Principal_getMaxLife, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::setMaxLife", XS_Heimdal__Kadm5__Principal_setMaxLife, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::getModName", XS_Heimdal__Kadm5__Principal_getModName, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getModDate", XS_Heimdal__Kadm5__Principal_getModDate, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getPolicy", XS_Heimdal__Kadm5__Principal_getPolicy, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getMaxRenewableLife", XS_Heimdal__Kadm5__Principal_getMaxRenewableLife, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::setMaxRenewableLife", XS_Heimdal__Kadm5__Principal_setMaxRenewableLife, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::getLastSuccess", XS_Heimdal__Kadm5__Principal_getLastSuccess, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getLastFailed", XS_Heimdal__Kadm5__Principal_getLastFailed, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getFailAuthCount", XS_Heimdal__Kadm5__Principal_getFailAuthCount, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getFailAuthCounts", XS_Heimdal__Kadm5__Principal_getFailAuthCounts, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getAttributes", XS_Heimdal__Kadm5__Principal_getAttributes, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::setAttributes", XS_Heimdal__Kadm5__Principal_setAttributes, file, "$$");
        newXSproto("Heimdal::Kadm5::Principal::getKeytypes", XS_Heimdal__Kadm5__Principal_getKeytypes, file, "$");
        newXSproto("Heimdal::Kadm5::Principal::getPassword", XS_Heimdal__Kadm5__Principal_getPassword, file, "$");
        newXSproto("Heimdal::Kadm5::constant", XS_Heimdal__Kadm5_constant, file, "$$");
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

